| ## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# csArrayElementHandler< T > Class Template Reference
[Containers]

The default element handler for csArray. More...

`#include <csutil/array.h>`

Inheritance diagram for csArrayElementHandler< T >:

[legend]
List of all members.

## Static Public Member Functions
static void | Construct (T *address, T const &src)
| Copy-construct an element.
static void | Construct (T *address)
| Construct an element.
static void | Destroy (T *address)
| Destroy an element.
static void | InitRegion (T *address, size_t count)
| Construct a number of elements.
static void | MoveElements (T *mem, size_t dest, size_t src, size_t count)
| Move elements inside a region.
template<typename Allocator>
static T * | ResizeRegion (Allocator &alloc, T *mem, size_t relevantcount, size_t oldcount, size_t newcount)
| Reallocates a region allocated by `Allocator`.

## Detailed Description

### template<class T>
class csArrayElementHandler< T >

The default element handler for csArray.

Definition at line 102 of file array.h.

## Member Function Documentation

template<class T>

static void csArrayElementHandler< T >::Construct | ( | T * | address,
|  | T const & | src |
| ) |  |  | `[inline, static]`

Copy-construct an element.

Reimplemented in csPDelArrayElementHandler< T >, csRefArrayElementHandler< T >, and csStringArrayElementHandler.

Definition at line 112 of file array.h.

template<class T>

static void csArrayElementHandler< T >::Construct | ( | T * | address | ) | `[inline, static]`

Construct an element.

Definition at line 106 of file array.h.

Referenced by csArrayElementHandler< const char * >::InitRegion().

template<class T>

static void csArrayElementHandler< T >::Destroy | ( | T * | address | ) | `[inline, static]`

Destroy an element.

Reimplemented in csPDelArrayElementHandler< T >, csRefArrayElementHandler< T >, and csStringArrayElementHandler.

Definition at line 118 of file array.h.

template<class T>

static void csArrayElementHandler< T >::InitRegion | ( | T * | address,
|  | size_t | count |
| ) |  |  | `[inline, static]`

Construct a number of elements.

Reimplemented in csPDelArrayElementHandler< T >, csRefArrayElementHandler< T >, and csStringArrayElementHandler.

Definition at line 124 of file array.h.

template<class T>

static void csArrayElementHandler< T >::MoveElements | ( | T * | mem,
|  | size_t | dest,
|  | size_t | src,
|  | size_t | count |
| ) |  |  | `[inline, static]`

Move elements inside a region.

Definition at line 140 of file array.h.

template<class T>
template<typename Allocator>

static T* csArrayElementHandler< T >::ResizeRegion | ( | Allocator & | alloc,
|  | T * | mem,
|  | size_t | relevantcount,
|  | size_t | oldcount,
|  | size_t | newcount |
| ) |  |  | `[inline, static]`

Reallocates a region allocated by `Allocator`.

Definition at line 132 of file array.h.

The documentation for this class was generated from the following file:

- csutil/array.h